//	Notes:
//		This is still pretty much untouched since the original version, and
//		needs changing to a proper debugger to really make the most of it.
//		Something like TurboMON would probably work quite well, tho how it'd
//		fit into the current implementation has not been finalised - maybe
//		a graphical overlay on the normal screen or something?
//
//		Currently there's still a Win32-specific key check that means I can
//		use it from within the VC++ debugger to do some very minimal stepping
//		and register checking.

#include "stdafx.h"

#include "Util.h"
#include "CPU.h"
#include "Debug.h"
#include "Disassem.h"
#include "Memory.h"

char waitforchar ();
extern int nDebugging;

int run_debug(WORD ThePC)
{		
	int TheChar;
	char sbuf[100];
/*
	static int FirstTime = 1;
			
	if (FirstTime) {
		TRACE("SimCoupe Z80 debugger, type h for help\n\n");
		FirstTime = !FirstTime;
	}	
*/

	int nLen = Disassemble(ThePC, sbuf, sizeof sbuf);
	TRACE(" %04x  ", ThePC);
	for (int j = 0 ; j < nLen ; j++) TRACE("%02x ", read_byte(ThePC+j));
	for (int k = nLen ; k < 4 ; k++) TRACE("   ");
	TRACE("  %s\n", sbuf);

//	Disassemble(ThePC, sbuf, sizeof sbuf);
//	TRACE("%s\n",sbuf);


	TheChar = waitforchar();

	switch (TheChar) {
		case 'r':
			TRACE("Returning to Emulation mode\n\n");

				nDebugging = 0;
				return(0);
				break;
			case 'z':
			{ 
				unsigned short wPC = ThePC-50;
				TRACE("Disassembly, type z to return\n");
				TRACE("address (in Hex) : ");
				TRACE("PC = %04x\n", ThePC);

				for (int i = 0 ; i < 150 ; i++)
				{
					int nLen = Disassemble(wPC, sbuf, sizeof sbuf);

					TRACE("%c%04x  ", wPC==ThePC ? '*' : ' ', wPC);
					for (int j = 0 ; j < nLen ; j++) TRACE("%02x ", read_byte(wPC+j));
					for (int k = nLen ; k < 4 ; k++) TRACE("   ");
					TRACE("  %s\n", sbuf);

					wPC += nLen;
				}
			}
			break;

			case 'x':
				return 1;
		}

		return(1);
}

char waitforchar()
{
#ifdef _WIN32
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		// Stop if we've got a keypress
		if (msg.message == WM_CHAR)
			break;

		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return LOBYTE(msg.wParam);
#else
	return 0;
#endif
}
