/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File mouse.h  public interface to the mouse handling 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MOUSE_H
#define MOUSE_H

namespace Mouse
{
	void Init ();
	void Exit ();

	BYTE Read (DWORD dwTime_);
	void Move (int nDeltaX_, int nDeltaY_);
	void SetButton (int nButton_, bool fPressed_=true);
};

#endif
