// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//
#ifndef STDAFX_H
#define STDAFX_H

#define _DEBUG

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <limits.h>

#define CUSTOM_MAIN

typedef unsigned char	BYTE;
typedef unsigned short	WORD;
typedef unsigned long	DWORD;
typedef unsigned int	UINT;
typedef signed long		LONG;
typedef void			VOID;
typedef DWORD			__int64;

#define BOOL			short
#define FALSE			0
#define TRUE			1

#define min(a,b) ((a)>(b)?(b):(a))
#define max(a,b) ((a)>(b)?(a):(b))

#define strcmpi			strcasecmp
#define OutputDebugString(str)	fprintf(stderr, str)
#define MessageBox(hwnd,body,title,flags)	fprintf(stderr, "%s: %s\n", title, body)
#define DebugBreak()

#define HIBYTE(w)		((BYTE)((WORD)w)>>8)
#define LOBYTE(w)		((BYTE)((WORD)w)&0x00ff)

#define _MAX_PATH		512

#ifdef _WIN32

#define WIN32_LEAN_AND_MEAN

#define strdup			_strdup


// For NT4 compatability we need to ensure than only DX3 features are used
#define DIRECTDRAW_VERSION		0x0300
#define DIRECT3D_VERSION		0x0300
#define DIRECTSOUND_VERSION		0x0300

// We need DX5 support for DInput joystick support, so we'll do run-time checks later for it in Input.cpp
//#define DIRECTINPUT_VERSION		0x0300


#include <windows.h>
#include <windowsx.h>

#include <mmsystem.h>
#include <ddraw.h>
#include <commdlg.h>
#include <shellapi.h>

extern HINSTANCE __hinstance;

#endif	// _WIN32

#endif STDAFX_H
