#ifndef VIDEO_H
#define VIDEO_H

#include "Display.h"
#include "IO.h"

namespace Video
{
	bool Init ();
	void Exit ();

	void Update ();
	void UpdatePalette ();
	bool UpdateDepth ();
	void UpdateOverlay ();

	void WaitVBlank ();
}

extern LPDIRECTDRAWSURFACE pddsPrimary, pddsFront, pddsBack;
extern DWORD aulPalette[N_PALETTE_COLOURS];
extern WORD awY[N_PALETTE_COLOURS], awU[N_PALETTE_COLOURS], awV[N_PALETTE_COLOURS];

class CDisplay;
extern CDisplay* g_pDisplay;


#endif	// VIDEO_H
